#!/bin/bash

# Check if user is root
if [ $(id -u) != "0" ]; then
    echo "Error: You must be root to run this script, use sudo sh $0"
    exit 1
fi

clear
echo "========================================================================="
echo "Add Virtual Host for LNAMP vhost V1.2 by MGRei "
echo ""
echo "For more information please visit http://www.mgrei.com/"
echo ""
echo "========================================================================="

if [ "$1" != "--help" ]; then

	domain="www.mgrei.com"
	read -p "Please input domain:" domain
	if [ "$domain" = "" ]; then
		echo "Error: Domain Name Can't be empty!!"
		exit 1
	fi
	if [ ! -f "/usr/local/nginx/conf/vhosts/$domain.conf" ]; then
	echo "==========================="
	echo "domain=$domain"
	echo "===========================" 
	else
	echo "==========================="
	echo "$domain is exist!"
	echo "==========================="	
	fi
	
	echo "Do you want to add more domain name? (y/n)"
	read add_more_domainame

	if [ "$add_more_domainame" == 'y' ]; then

	  echo "Type domainname,example(bbs.vpser.net forums.vpser.net luntan.vpser.net):"
	  read moredomain
          echo "==========================="
          echo domain list="$moredomain"
          echo "==========================="
	  moredomainame=" $moredomain"
	fi

	vhostdir="/home/www/$domain"
	echo "Please input the directory for the domain:$domain :"
	read -p "(Default directory: /home/www/$domain):" vhostdir
	if [ "$vhostdir" = "" ]; then
		vhostdir="/home/www/$domain"
	fi
	echo "==========================="
	echo Virtual Host Directory="$vhostdir"
	echo "==========================="

#set Server Administrator Email Address

	ServerAdmin=""
	read -p "Please input Administrator Email Address:" ServerAdmin
	if [ "$ServerAdmin" == "" ]; then
		echo "Administrator Email Address will set to webmaster@$domain!"
		ServerAdmin="webmaster@$domain"
	else
	echo "==========================="
	echo Server Administrator Email="$ServerAdmin"
	echo "==========================="
	fi

	get_char()
	{
	SAVEDSTTY=`stty -g`
	stty -echo
	stty cbreak
	dd if=/dev/tty bs=1 count=1 2> /dev/null
	stty -raw
	stty echo
	stty $SAVEDSTTY
	}
	echo ""
	echo "Press any key to start create virtul host..."
	char=`get_char`


if [ ! -d /usr/local/nginx/conf/vhosts ]; then
	mkdir /usr/local/nginx/conf/vhosts
fi

echo "Create Virtul Host directory......"
mkdir -p $vhostdir
touch /usr/local/nginx/logs/$domain.log
echo "set permissions of Virtual Host directory......"
chmod -R 755 $vhostdir
chown -R www:www $vhostdir

cat >/usr/local/nginx/conf/vhosts/$domain.conf<<eof
server
{
listen       80;
server_name www.$domain $domain$moredomainame;
index index.html index.htm index.php default.html default.htm default.php;
root  $vhostdir;

location / {
    try_files \$uri @backend;
    location ~* \.(jpg|jpeg|png|gif|bmp|ico|mp3|wav|swf|mov|doc|pdf|xls|ppt|docx|pptx|xlsx|js|css|zip|tar|gz|rar)\$ {
expires      30d;
    }
  }
  location @backend {
    internal;
    proxy_pass http://127.0.0.1:81;
    include proxy.conf;
  }
  location ~ .*\.(php|jsp|cgi|pl|py|php4|php5|htaccess)?\$ {
    proxy_pass http://127.0.0.1:81;
    include proxy.conf;
  }
  location ~ .*\.(ftpquota|htaccess|htpasswd|asp|aspx|jsp|asa|mdb)?\$ {
    deny all;
  }
}
eof

cat >/usr/local/apache/conf/vhosts/$domain.conf<<eof
<VirtualHost *:81>
ServerAdmin webmaster@$domain
DocumentRoot "$vhostdir"
ServerName $domain
ServerAlias www.$domain$moredomainame
ErrorLog "logs/$domain-error_log"
CustomLog "logs/$domain-access_log" common
</VirtualHost>
eof

echo "Test Nginx configure file......"
/usr/local/nginx/sbin/nginx -t
echo ""
echo "Restart Nginx......"
service nginx reload
echo "Restart Apache......"
service httpd restart

echo "========================================================================="
echo "Add Virtual Host for LNAMP vhost V1.2 by MGRei "
echo "========================================================================="
echo "For more information please visit http://www.mgrei.com/"
echo "========================================================================="
echo ""
echo "Your domain:$domain $moredomainame"
echo "Directory of $domain:$vhostdir"
echo ""
echo "========================================================================="
fi